package com.xydl.util;

import org.eclipse.paho.client.mqttv3.*;
import org.eclipse.paho.client.mqttv3.persist.MemoryPersistence;

import java.text.SimpleDateFormat;
import java.util.Date;

public class MqttUtil {

    public static boolean publish2MQTT(String content){
        String broker = "tcp://139.196.211.222:10883";
        String topic = "mqtt/test";
//        String content = "Hello MQTT";
        int qos = 0;
        String username = "test";
        String password = "AliOS%1688";
        String clientid = "publish_client";
        MqttClient client;
        MqttDeliveryToken token;
        try {
            client = new MqttClient(broker, clientid, new MemoryPersistence());
        } catch (MqttException e) {
            throw new RuntimeException(e);
        }
        MqttConnectOptions options = new MqttConnectOptions();
        options.setUserName(username);
        options.setPassword(password.toCharArray());
        options.setConnectionTimeout(60);
        options.setKeepAliveInterval(30);
        // connect
        try {
            client.connect(options);
        } catch (MqttException e) {
            throw new RuntimeException(e);
        }
        // create message and setup QoS
        MqttMessage message = new MqttMessage(content.getBytes());
        message.setQos(qos);
        // publish message
        try {
            token = client.getTopic(topic).publish(message);
            token.waitForCompletion();
            //打印发送状态
            System.out.println("messagei is published completely!" + token.isComplete());
//            client.publish(topic, message);
        } catch (MqttException e) {
            throw new RuntimeException(e);
        }
        System.out.println("Message published");
        System.out.println("topic: " + topic);
        System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date())+ " message content推送: " + content);
        // disconnect
        try {
            client.disconnect();
        } catch (MqttException e) {
            throw new RuntimeException(e);
        }
        // close client
        try {
            client.close();
        } catch (MqttException e) {
            throw new RuntimeException(e);
        }

        return token.isComplete();
    }

    public static  void subScribeMQTT(){
        String broker = "tcp://139.196.211.222:10883";
        String topic = "mqtt/test";
        String username = "test";
        String password = "AliOS%1688";
        String clientid = "subscribe_client";
        int qos = 0;
        try {
            MqttClient client = new MqttClient(broker, clientid, new MemoryPersistence());
            // connect options
            MqttConnectOptions options = new MqttConnectOptions();
            options.setUserName(username);
            options.setPassword(password.toCharArray());
            options.setConnectionTimeout(60);
            options.setKeepAliveInterval(30);
            // setup callback
            client.setCallback(new MqttCallback() {
                public void connectionLost(Throwable cause) {
                    System.out.println("connectionLost: " + cause.getMessage());
                }
                public void messageArrived(String topic, MqttMessage message) {
                    System.out.println("topic: " + topic);
                    System.out.println("Qos: " + message.getQos());
                    System.out.println(new SimpleDateFormat("yyyy-MM-dd HH:mm:ss").format(new Date())+" message content接收: " + new String(message.getPayload()));

                }
                public void deliveryComplete(IMqttDeliveryToken token) {
                    System.out.println("deliveryComplete---------" + token.isComplete());
                }
            });
            client.connect(options);
            client.subscribe(topic, qos);
        } catch (Exception e) {
            e.printStackTrace();       }
    }


}
